--[[******************************************
*
*	Multi Theft Auto - Auto Muter
*
*	automuter.lua
*
*	Made by [DRuG]Dabombber
*
**********************************************]]

local root = getRootElement ( )
local Player = { Ticks = {} , Timer = {} , LastMessage = {} , RepeatMessages = {} , RepeatLast = {} }
local Settings = {}

addEventHandler( "onResourceStart" , getResourceRootElement( getThisResource ( ) ) ,
	function ( )
		if ( not hasObjectPermissionTo ( getThisResource ( ) , "function.setPlayerMuted" , false ) ) then
			outputServerLog ( "AUTOMUTER: Incorrect ACL settings, automuter needs access to function.setPlayerMuted" )
			return
		end

		for _ , value in ipairs ( { "MessageCount" , "MessageTime" , "MuteTime" , "RepeatMessages" , "RepeatTime" , "MinMuteTime" } ) do
			Settings[value] = get( value )
			if ( type ( Settings[value] ) ~= "number" or math.ceil ( Settings[value] ) ~= Settings[value] ) then
				outputServerLog ( "AUTOMUTER: Invalid configuration settings (" .. value .. ")" )
				return
			end
		end

		for _ , value in ipairs ( { "HideNames" , "RepeatBlock" , "StopVotespam" } ) do
			local setting = get( value )
			if ( setting and type ( setting ) == "string" and setting == "true" ) then
				Settings[value] = true
			else
				Settings[value] = false
			end
		end

		Settings["VoteSpamRegex"] = get( "VoteSpamRegex" )

		if ( ( Settings.RepeatMessages > 1 and Settings.RepeatTime > 0 ) or ( Settings.MessageCount > 1 and Settings.MessageTime > 0 ) or Settings.StopVotespam ) then
			addEventHandler( "onPlayerChat" , root ,
				function ( message , messageType )
					local tick = getTickCount ( )
					if ( Settings.MessageCount > 1 and Settings.MessageTime > 0 ) then
						Player.Ticks[source] = Player.Ticks[source] or {}
						if ( #Player.Ticks[source] == Settings.MessageCount - 1 ) then
							if ( tick - Player.Ticks[source][Settings.MessageCount - 1] < Settings.MessageTime ) then
								autoMutePlayer ( source )
								cancelEvent ( )
								Player.Ticks[source] = {}
								return
							else
								table.remove ( Player.Ticks[source] )
							end
						end
						table.insert ( Player.Ticks[source] , 1 , tick )
					end
					if ( Settings.RepeatMessages > 1 and Settings.RepeatTime > 0 ) then
						if ( Player.LastMessage[source] and Player.LastMessage[source] == message and Player.RepeatLast[source] and tick - Player.RepeatLast[source] <  Settings.RepeatTime * 1000 ) then
							Player.RepeatMessages[source] = Player.RepeatMessages[source] + 1
							if ( Player.RepeatMessages[source] >= Settings.RepeatMessages - 1 ) then
								autoMutePlayer ( source )
								cancelEvent ( )
								Player.RepeatMessages[source] = 0
								Player.LastMessage[source] = nil
								Player.RepeatLast[source] = nil
								return
							elseif ( Settings.RepeatBlock ) then
								outputChatBox ( "Please do not repeat yourself" , source , 255 , 0 , 0 )
								cancelEvent ( )
								return
							end
						else
							Player.RepeatMessages[source] = 0
						end
						Player.LastMessage[source] = message
						Player.RepeatLast[source] = tick
					end
					if ( Settings.StopVotespam ) then
						if ( string.find ( message , Settings.VoteSpamRegex ) ) then
							local ret , err = call ( getResourceFromName ( "votemanager" ) , "startPoll" )
							if ( ret == false and err == 10 ) then	-- pollAlreadyRunning
								outputChatBox ( "Please do not votespam" , source , 255 , 0 , 0 )
								cancelEvent ( )
							end
						end
					end
				end
			)
		end

		addEventHandler( "onPlayerQuit" , root ,
			function ( )
				Player.LastMessage[source] = nil
				Player.RepeatMessages[source] = nil
				Player.Ticks[source] = nil
				if ( isTimer ( Player.Timer[source] ) ) then
					killTimer ( Player.Timer[source] )
				end
				Player.Timer[source] = nil
			end
		)

		addEventHandler( "onResourceStop" , getResourceRootElement( getThisResource ( ) ) ,
			function ( )
				for _ , player in ipairs ( getElementsByType( "player" ) ) do
					if ( isTimer ( Player.Timer[player] ) ) then
						killTimer ( Player.Timer[player] )
						setPlayerMuted ( player , false )
						outputMsg ( getPlayerName ( player ) .. " has been unmuted" , 0 , 255 , 255 )
					end
				end
			end
		)

		addCommandHandler ( "amute" , mutePlayer )
		addCommandHandler ( "aunmute" , unmutePlayer )
	end
)

function outputMsg ( message , red , green , blue )
	outputChatBox ( message , root , red , green , blue )
	outputServerLog ( "AUTOMUTER: " .. message )
end

function autoMutePlayer ( player )
	if ( Settings.MuteTime > 0 ) then
		if ( Player.Timer[player] ) then return end
		outputMsg ( getPlayerName ( player ) .. " has been muted for " .. tostring ( Settings.MuteTime ) .. " seconds (spam)" , 255 , 0 , 0 )
		setPlayerMutedEx ( player , true , Settings.MuteTime )
	else
		outputMsg ( getPlayerName ( player ) .. " has been muted (spam)" , 255 , 0 , 0 )
		setPlayerMutedEx ( player , true )
	end
end

function autoUnmutePlayer ( player )
	if ( isPlayerMuted ( player ) ) then
		setPlayerMuted ( player , false )
		outputMsg ( getPlayerName ( player ) .. " has been unmuted" , 0 , 255 , 255 )
	end
	Player.Timer[player] = nil
end

function unmutePlayer ( player , commandName, targetplayer )
	if ( isGuestAccount( getPlayerAccount( player ) ) or not hasObjectPermissionTo( player , "function.setPlayerMuted" , false ) ) then return end

	local sauce = getElementType ( player )

	if ( not targetplayer ) then
		if ( sauce == "player" ) then
			outputChatBox ( "aunmute: Usage \"/unmute player\"" , player , 255 , 0 , 0 )
		elseif ( sauce == "console" ) then
			outputServerLog( "aunmute: Usage \"/unmute player\"" )
		end
		return
	end

	local target = FindPlayer ( targetplayer )
	if ( not target ) then
		if ( sauce == "player" ) then
			outputChatBox ( "aunmute: Player not found" , player , 255 , 0 , 0 )
		elseif ( sauce == "console" ) then
			outputServerLog( "aunmute: Player not found" )
		end
		return
	end

	if ( not isPlayerMuted ( target ) ) then
		if ( sauce == "player" ) then
			outputChatBox ( "aunmute: " .. getPlayerName ( target ) .. " is not muted" , player , 255 , 168 , 0 )
		elseif ( sauce == "console" ) then
			outputServerLog( "aunmute: " .. getPlayerName ( target ) .. " is not muted" )
		end
		return
	end

	setPlayerMutedEx ( target , false )

	if ( Settings.HideNames or sauce ~= "player" ) then
		outputMsg ( getPlayerName ( target ) .. " has been unmuted" , 0 , 255 , 255 )
	elseif ( player == target ) then
		outputMsg ( getPlayerName ( target ) .. " has unmuted themself " , 0 , 255 , 255 )
	else
		outputMsg ( getPlayerName ( target ) .. " has been unmuted by " .. getPlayerName ( player ) , 0 , 255 , 255 )
	end
end

function mutePlayer ( player , commandName , targetplayer , ... )
	if ( isGuestAccount( getPlayerAccount( player ) ) or not hasObjectPermissionTo( player , "function.setPlayerMuted" , false ) ) then return end

	local sauce = getElementType ( player )
	if ( not targetplayer ) then
		if ( sauce == "player" ) then
			outputChatBox ( "mute: Usage \"/amute player (time) (reason)\"" , player , 255 , 0 , 0 )
		elseif ( sauce == "console" ) then
			outputServerLog( "mute: Usage \"/amute player (time) (reason)\"" )
		end
		return
	end

	local target = FindPlayer ( targetplayer )
	if ( not target ) then
		if ( sauce == "player" ) then
			outputChatBox ( "amute: Player not found" , player , 255 , 0 , 0 )
		elseif ( sauce == "console" ) then
			outputServerLog( "amute: Player not found" )
		end
		return
	end

	if ( target == player ) then
		outputChatBox ( "amute: You cannot mute yourself" , player , 255 , 168 , 0 )
		return
	end

	if ( isPlayerMuted ( target ) ) then
		if ( sauce == "player" ) then
			outputChatBox ( "amute: " .. getPlayerName ( target ) .. " is already muted" , player , 255 , 168 , 0 )
		elseif ( sauce == "console" ) then
			outputServerLog( "amute: " .. getPlayerName ( target ) .. " is already muted" )
		end
		return
	end

	if ( arg[1] and string.find ( arg[1] , "^%d+$" ) ) then
		local seconds = tonumber ( arg[1] )
		if ( seconds < Settings.MinMuteTime ) then
			seconds = Settings.MinMuteTime
		end
		setPlayerMutedEx ( target , true , seconds )
		local reason = table.concat ( arg , " " , 2)
		if ( Settings.HideNames or sauce ~= "player" ) then
			if ( reason and reason ~= "" ) then
				outputMsg ( getPlayerName ( target ) .. " has been muted for " .. tostring ( seconds ) .. " seconds (" .. reason .. ")" , 255 , 0 , 0 )
			else
				outputMsg ( getPlayerName ( target ) .. " has been muted for " .. tostring ( seconds ) .. " seconds" , 255 , 0 , 0 )
			end
		else
			if ( reason and reason ~= "" ) then
				outputMsg ( getPlayerName ( target ) .. " has been muted for " .. tostring ( seconds ) .. " seconds by " .. getPlayerName ( player ) .. " (" .. reason .. ")" , 255 , 0 , 0 )
			else
				outputMsg ( getPlayerName ( target ) .. " has been muted for " .. tostring ( seconds ) .. " seconds by " .. getPlayerName ( player ) , 255 , 0 , 0 )
			end
		end
	else
		setPlayerMutedEx ( target , true )
		local reason = table.concat ( arg , " " )
		if ( Settings.HideNames or sauce ~= "player" ) then
			if ( reason and reason ~= "" ) then
				outputMsg ( getPlayerName ( target ) .. " has been muted (" .. reason .. ")" , 255 , 0 , 0 )
			else
				outputMsg ( getPlayerName ( target ) .. " has been muted" , 255 , 0 , 0 )
			end
		else
			if ( reason and reason ~= "" ) then
				outputMsg ( getPlayerName ( target ) .. " has been muted by " .. getPlayerName ( player ) .. " (" .. reason .. ")" , 255 , 0 , 0 )
			else
				outputMsg ( getPlayerName ( target ) .. " has been muted  by " .. getPlayerName ( player ) , 255 , 0 , 0 )
			end
		end
	end
end

function setPlayerMutedEx ( player , muted , seconds )
	setPlayerMuted ( player , muted )
	if ( isTimer ( Player.Timer[player] ) ) then
		killTimer ( Player.Timer[player] )
	end
	if ( seconds and muted ) then
		Player.Timer[player] = setTimer ( autoUnmutePlayer , seconds * 1000 , 1 , player )
	else
		Player.Timer[player] = nil
	end
end

function FindPlayer ( text )
	local player = getPlayerFromName ( text )
	if ( player ) then return player end
	local lowtext = string.lower ( text )
	for id , player in ipairs ( getElementsByType ( "player" ) ) do
		if ( string.find ( string.lower ( getPlayerName ( player ) ), lowtext , 1 , true ) ) then
			return player
		end
	end
	return false
end
